# Oswald chatbot module

## Composer installation

```composer require drupal/oswald```
- Surf to you modules overview page.
- Enable the Oswald module.
### Configuration
- navigate to /admin/config/oswald/bots
- Add a chatbot.
  - Give it a proper name
  - Take the chabot id from (https://app.oswald.ai/ > Integrations > API > Click on "API Token")
  - Enable or disable the chatbot
  - select environment "production" unless instructed otherwise.

You can now in the bots overview "test" your bot.
If your bot is enabled it will be active in the theme (not in the admin theme).

   
### Extend

in oswald.api.php you can find an example implementation on how to integrate multiple chatbots in one site.
```
function hook_oswald_active_bot_alter(&$data) {
     foreach ($data['bots'] as $key => $chatbot) {
       if ($data['route'] == 'my_custom_route') {
         // Select this bot, leave it in the array.
       }
       else {
         unset($data['bots'][$key]);
       }
     }
   }
```
Implement the hook_oswald_active_bot_alter to customize which bot should be shown on which url.
Make sure the code is lightweight as this hook is called on every request.

Some example implementations:
- Show a different bot for every role.
- show a different bot on different sections of the site
- show different bots on some but not other pages.

Thanks for using oswald. 
