<?php

/**
 * @file
 * Hooks provided by the Oswald module.
 */

/**
 * @addtogroup hooks
 * @{
 */

/**
 * Alter the available enabled chatbots before page laod.
 *
 * Modules may implement this hook to select which chatbot should be active on which page.
 * The implementing module should only leave the 1 chatbot in the array that should be shown.
 *
 * @param array $data
 *   This parameter contains tjhe enabled chatbots, the user object and the current route.
 */
function hook_oswald_active_bot_alter(&$data) {
  foreach ($data['bots'] as $key => $chatbot) {
    if ($data['route'] == 'my_custom_route') {
      // Select this bot, leave it in the array.
    }
    else {
      unset($data['bots'][$key]);
    }
  }
}

/**
 * @} End of "addtogroup hooks".
 */
