<?php

namespace Drupal\oswald;

use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Entity\EntityListBuilder;
use Drupal\Core\Link;
use Drupal\Core\Url;

/**
 * Defines a class to build a listing of oswald_bot entities.
 *
 * @see \Drupal\oswald\Entity\OswaldBot
 */
class OswaldBotListBuilder extends EntityListBuilder {

  /**
   * {@inheritdoc}
   */
  public function buildHeader() {
    $header['label'] = t('Label');
    $header['oswald_bot_id'] = t('oswald bot id');
    $header['enabled'] = t('Enabled');
    $header['environment'] = t('Environment');
    return $header + parent::buildHeader();
  }

  /**
   * {@inheritdoc}
   */
  public function buildRow(EntityInterface $entity) {
    $label = !empty($entity->get('name')->getValue()[0]['value']) ? $entity->get('name')->getValue()[0]['value'] : $entity->id();
	  $row['label'] = new Link($label, Url::fromRoute("entity.oswald_bot.canonical", ["oswald_bot" => $entity->id()]));
    $row['oswald_bot_id'] = $entity->get('oswald_bot_id')->getValue()[0]['value'];
	  $row['enabled'] = ($entity->get('enabled')->getValue()[0]['value'])?t('Enabled'): t('Disabled');
    $row['environment'] = $entity->get('environment')->getValue()[0]['value'];
    return $row + parent::buildRow($entity);
  }




  /**
   * {@inheritdoc}
   */
  public function getDefaultOperations(EntityInterface $entity) {
    $operations = parent::getDefaultOperations($entity);
    return $operations;
  }

}

